/*Progettare un programma C che 
legge da stdin 
due interi positivi k e val, ed una sequenza Q
di interi positivi.
La sequenza di interi e' terminata dal'intero 0
(che non appartiene alla sequenza).
Il programma inserisce l'intero val nella sequenza Q
in posizione k ottenendo cosi' una sequenza Q'. 
Il programma stampa su stdout
il vostro nome, cognome, data di nascita, email,
e la sequenza Q' (un intero per riga) terminata da 0,
seguito da un newline.

Non si possono fare ipotesi sul numero di interi
da leggere. Quindi dovete usare una allocazione dinamica
della memoria.
Per semplicita' potete assumere che il k inserito sia
valido (ovvero compreso tra 1 ed il numero di elementi
della lista piu' uno).
*/

#include <stdio.h>


struct nodolista {
	int Info;
	struct nodolista * Next;
};

typedef struct nodolista NodoLista;
typedef NodoLista * PtrNodo;


PtrNodo creaElemento()
	{
	return (PtrNodo)malloc(sizeof(NodoLista));
	}

void aggiungiValore(PtrNodo * InizioLista, int val)
	{
	PtrNodo nuovo;
	if(*InizioLista==NULL)
		{
		nuovo = creaElemento();
		nuovo->Info = val;
		nuovo->Next = NULL;
		*InizioLista = nuovo;
		}
	else
		aggiungiValore(&(*InizioLista)->Next,val);
	}


PtrNodo eliminaValore(PtrNodo InizioLista,int posizione)
	{
	PtrNodo temp;
	
	if(posizione==1||InizioLista==NULL)
		{
		temp=InizioLista->Next;
		free(InizioLista);
		return temp;
		}
	InizioLista->Next=eliminaValore(InizioLista->Next,posizione-1);
	return InizioLista;
	}

void stampaLista(PtrNodo InizioLista)
	{
	if(InizioLista!=NULL)
		{
		printf("%d\n",InizioLista->Info);
		stampaLista(InizioLista->Next);		
		}
	}

int main()
	{
	PtrNodo Lista;
	char cmd[5];
	int val,
	    pos;

	Lista = NULL;

	scanf("%s",cmd);

	while(strcmp(cmd,"q"))
		{
		if(!strcmp(cmd,"i")) {
			scanf("%d",&val);
			aggiungiValore(&Lista,val);
			}
		else
			if(!strcmp(cmd,"d")) {
				scanf("%d",&pos);
				Lista = eliminaValore(Lista,pos);
				}
			else
				if(!strcmp(cmd,"p"))
					stampaLista(Lista);
		scanf("%s",cmd);
		}

	
	return 0;
	}
