/*Progettare un programma C che legge da stdin una sequenza di
righe del tipo
<cmd> <int>
dove:
cmd e' uno dei seguenti caratteri: i, d, p;
<int> e' un intero.

Il vostro programma gestisce una lista come segue.

Leggendo la riga
i val
viene inserito val come ULTIMO elemento (tail) della lista.

Leggendo la riga
d k
viene cancellato il k-esimo (k > 0) elemento dalla lista
(la testa della lista si considera in posizione 1, primo elemento).

Leggendo la riga
p val
viene stampato il contenuto della lista.

Leggendo la riga
q val
il programma termina 
(il valore val non e' usato, e' stato inserito solo per 
facilitare la lettura).
*/

#include <stdio.h>
#include <stdlib.h>


struct nodolista {
	int Info;
	struct nodolista * Next;
};

typedef struct nodolista NodoLista;
typedef NodoLista * PtrNodo;


PtrNodo creaElemento()
	{
	return (PtrNodo)malloc(sizeof(NodoLista));
	}

void aggiungiValore(PtrNodo * InizioLista, int val)
	{
	PtrNodo nuovo;
	if(*InizioLista==NULL)
		{
		nuovo = creaElemento();
		nuovo->Info = val;
		nuovo->Next = NULL;
		*InizioLista = nuovo;
		}
	else
		aggiungiValore(&(*InizioLista)->Next,val);
	}


PtrNodo eliminaValore(PtrNodo InizioLista,int posizione)
	{
	PtrNodo temp;
	
	if(posizione==1||InizioLista==NULL)
		{
		temp=InizioLista->Next;
		free(InizioLista);
		return temp;
		}
	InizioLista->Next=eliminaValore(InizioLista->Next,posizione-1);
        return InizioLista;
	}

void stampaLista(PtrNodo InizioLista)
	{
	if(InizioLista!=NULL)
		{
		printf("%d\n",InizioLista->Info);
		stampaLista(InizioLista->Next);		
		}
	}

int main()
	{
	PtrNodo Lista;
	char cmd[5];
	int val,
	    pos;

	Lista = NULL;

	scanf("%s",cmd);

	while(strcmp(cmd,"q"))
		{
		if(!strcmp(cmd,"i")) {
			scanf("%d",&val);
			aggiungiValore(&Lista,val);
			}
		else
			if(!strcmp(cmd,"d")) {
				scanf("%d",&pos);
				Lista = eliminaValore(Lista,pos);
				}
			else
				if(!strcmp(cmd,"p"))
					stampaLista(Lista);
		scanf("%s",cmd);
		}


	return 0;
	}
