/*Progettare un programma C che legge da stdin una sequenza di
righe del tipo
<cmd> <int>
dove:
cmd e' uno dei seguenti caratteri: i, d, p;
<int> e' un intero.

Il vostro programma gestisce una lista come segue.

Leggendo la riga
i val
viene inserito val come prima elemento (head) della lista.

Leggendo la riga
d k
viene cancellato il k-esimo (k > 0) elemento dalla lista
(la testa della lista si considera in posizione 1, primo elemento).

Leggendo la riga
p
viene stampato il contenuto della lista, a partire dalla testa.

Leggendo la riga
q
il programma termina.*/

/*---------------------------------PROGRAMMA------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#define forever for(;;)

struct nodolista {
   int Info;
   struct nodolista * Next;
};

typedef struct nodolista Nodo;
typedef Nodo* PtrNodo;

PtrNodo inserisciNodo(PtrNodo,int),
        cancellaNodo(PtrNodo,int),
        creaElemento();

void stampaLista(PtrNodo);

int main()
{
char comando[5];
int valore,
    posizione;

PtrNodo Lista = NULL;

   scanf("%s",comando);

   forever {
      
      if(!strcmp(comando,"q"))
         return 0;
      else
         if(!strcmp(comando,"i")) {
            scanf("%d",&valore);
            Lista = inserisciNodo(Lista,valore);   
          }
         else
            if(!strcmp(comando,"d")) {
               scanf("%d",&posizione);
               Lista = cancellaNodo(Lista,posizione);
            }
            else
               if(!strcmp(comando,"p"))
                  stampaLista(Lista);
     
       scanf("%s",comando);
    }  
}



PtrNodo creaElemento()
{
   return (PtrNodo)malloc(sizeof(Nodo));
}

PtrNodo inserisciNodo(PtrNodo lista, int val)
{
PtrNodo nuovo;

   nuovo = creaElemento();
   nuovo->Info = val;
   nuovo->Next = lista;
   
   return nuovo;
}

PtrNodo cancellaNodo(PtrNodo lista, int pos)
{
PtrNodo old;

   if(lista == NULL)
      return lista;

   if(pos == 1) {
      old = lista->Next;
      free(lista);
      return old;
   }
   
   lista->Next = cancellaNodo(lista->Next,pos-1);
   return lista;
}

void stampaLista(PtrNodo lista) 
{
   if(lista!=NULL) {
      printf("%d\n",lista->Info);
      stampaLista(lista->Next);
   }
}