/**********************STACK********************************

Dichiarazione e definizione di una stack (o pila). Lo stack
e' detto anche struttura di dati LIFO (last-in, first-out:
l'ultimo ad entrare e' il primo a uscire).

***********************************************************/

#include <stdio.h>
#include <stdlib.h>

struct stack{
   int Info;
   struct stack *Next;
   };


typedef struct stack NodoStack;
typedef NodoStack *PtrStack;


/*A differenza delle liste concatenate, nello stack l'inserimento
  viene effettuato sempre dalla testa...
  Le principali funzioni per gestire una pila sono "push" e "pop".

  --> La funzione "push" crea un nuovo nodo e lo posiziona in
      cima alla pila.
  --> La funzione "pop" rimuove un nodo dalla testa della
      pila.
*/

void push(PtrStack *S, int valore)
{
PtrStack nuovo,old;

   nuovo = (PtrStack)malloc(sizeof(NodoStack));

   if(nuovo == NULL) {
      printf("Memoria insufficiente");
   }
   else
   {
      nuovo->Next = *S;
      nuovo->Info = valore;
      *S = nuovo;
   }

}
int pop(PtrStack *S)
{
PtrStack successivo;
int valore;


   successivo = (*S)->Next;
   valore = (*S)->Info;
   free(*S);
   *S = successivo;

   return valore;
}

int isEmpty(PtrStack S)
{
   return S == NULL;
}


void stampaStack(PtrStack S)
{
   if(S!=NULL)
   {
      printf("%d\n",S->Info);
      stampaStack(S->Next);
   }
}
