/*
Progettare un programma C che 
legge in preordine da stdin un albero binario T etichettato con caratteri
e stampa in inorder su sdtout l'albero ottenuto da T
sostituendo tutte le vocali minuscole con il carattere *.
*/

#include <stdio.h>
#include <stdlib.h>

struct nodo {
   struct nodo *Left;
   char Info;
   struct nodo *Right;
};

typedef struct nodo NodoAlbero;
typedef NodoAlbero *PtrNodo;

PtrNodo leggiPreOrder();
void modificaEtichette(PtrNodo t);
void stampaInOrder(PtrNodo t);

int main()
{
   PtrNodo MyTree;

   MyTree = leggiPreOrder();

   modificaEtichette(MyTree);

   stampaInOrder(MyTree);

     return 0;
}


PtrNodo creaElemento()
{
   return (PtrNodo)malloc(sizeof(NodoAlbero));
}

PtrNodo leggiPreOrder()
{
PtrNodo nuovo;
int numero_figli;
char carattere;

   nuovo = creaElemento();
   
   scanf("%d %c",&numero_figli, &carattere);
   nuovo->Info = carattere;

   if(numero_figli==2) {
      nuovo->Left = leggiPreOrder();
      nuovo->Right = leggiPreOrder();
   }
   else
      if(numero_figli==1) {
         nuovo->Left = leggiPreOrder();
         nuovo->Right = NULL;
      }
      else {
         nuovo->Left = NULL;
         nuovo->Right = NULL;
      }
   
   return nuovo;
}


void modificaEtichette(PtrNodo t)
{
   if(t!=NULL)
   {
      if(t->Info >= 'a' && t->Info <= 'z')
         t->Info = '*';
      modificaEtichette(t->Left);
      modificaEtichette(t->Right);
   }
}

void stampaInOrder(PtrNodo t)
{
   if(t!=NULL) {
      stampaInOrder(t->Left);
      printf("%c\n", t->Info);
      stampaInOrder(t->Right);
   }
}