/*
Progettare un programma C che legge da stdin
un albero binario di interi in preordine, cancella i nodi che
hanno un unico figlio dall'albero e stampa l'albero risultante
in inorder. La cancellazione di un nodo x con un unico figlio y 
significa che il padre di x avra' come figlio al posto di x
y. Se y e' ha a sua volta un unico figlio allora anche y sara'
cancellato etc.
*/

#include <stdio.h>
#include <stdlib.h>


struct nodotree {

        struct nodotree * Left;
        int Info;
        struct nodotree * Right;
        };

typedef struct nodotree NodoTree;
typedef NodoTree * PtrTree;

PtrTree creaElemento(void);
PtrTree leggiPreOrdine(void);
PtrTree cancellaNodi(PtrTree T);
void stampaInOrdine(PtrTree T);



int main()
{
PtrTree MyTree = NULL;

   MyTree = leggiPreOrdine();
   MyTree = cancellaNodi(MyTree);
   stampaInOrdine(MyTree);
return 0;
}

PtrTree creaElemento(void)
   {
      return (PtrTree)malloc(sizeof(NodoTree));
   }

PtrTree leggiPreOrdine(void)
   {
   PtrTree Nuovo;
   int etichetta;
   int NumeroFigli;

      scanf("%d %d",&NumeroFigli,&etichetta);

      Nuovo = creaElemento();

      Nuovo->Info=etichetta;

      if(NumeroFigli==2) {
         Nuovo->Left=leggiPreOrdine();
         Nuovo->Right=leggiPreOrdine();
         }
      else
         if(NumeroFigli==1) {
            Nuovo->Left=leggiPreOrdine();
            Nuovo->Right = NULL;
            }
         else {
            Nuovo->Left=NULL;
            Nuovo->Right = NULL;
            }


      return Nuovo;

 }




PtrTree cancellaNodi(PtrTree T)
{
PtrTree figlio;
if(T == NULL)
   return T;

T->Left = cancellaNodi(T->Left);
T->Right = cancellaNodi(T->Right);

if(T->Left!=NULL&&T->Right==NULL) {
   figlio = T->Left;
   free(T);
   return figlio;
}
if(T->Left==NULL&&T->Right!=NULL) {
   figlio = T->Right;
   free(T);
   return figlio;
}

return T;
}

void stampaInOrdine(PtrTree T)
{
   if(T!=NULL)
   {
      stampaInOrdine(T->Left);
      printf("%d\n",T->Info);
      stampaInOrdine(T->Right);
   }
}


