/*
Progettare un programma C che 
legge da stdin un albero binario in preordine e stampa
in postordine su sdtout l'albero ottenuto sostituendo
l'etichetta di ogni nodo r con il prodotto delle etichette
del sottoalbero con radice r (r e' incluso nel prodotto). 
Le foglie restano invariate.
*/ 

#include <stdio.h>
#include <stdlib.h>
struct nodotree {

        struct nodotree * Left;
        int Info;
        struct nodotree * Right;
        };



typedef struct nodotree NodoTree;
typedef NodoTree * PtrNodoTree;


void stampaPostOrdineR(PtrNodoTree PtrTree);
int modificaEtichette(PtrNodoTree Tree);
PtrNodoTree leggiPreOrdine(void),
            creaElemento(void);


void main()
   {
      PtrNodoTree MyTree;

      MyTree = leggiPreOrdine();
      modificaEtichette(MyTree);
      stampaPostOrdineR(MyTree);
   }


PtrNodoTree creaElemento(void)
   {
      return (PtrNodoTree)malloc(sizeof(NodoTree));
   }



PtrNodoTree leggiPreOrdine(void)
   {
   PtrNodoTree Nuovo;
   int val;
   int NumeroFigli;

      scanf("%d %d",&NumeroFigli,&val);

      Nuovo = creaElemento();

      Nuovo->Info=val;

      if(NumeroFigli==2)
      {
         Nuovo->Left=leggiPreOrdine();
         Nuovo->Right=leggiPreOrdine();
      }
      else
         if(NumeroFigli==1)
         {
            Nuovo->Left=leggiPreOrdine();
            Nuovo->Right = NULL;
         }
         else
         {
            Nuovo->Left=NULL;
            Nuovo->Right = NULL;
         }

   return Nuovo;
}

int modificaEtichette(PtrNodoTree Tree)
{
int InfoFiglio1,
    InfoFiglio2;
   
   if(Tree==NULL)
      return 1;

   InfoFiglio1 = modificaEtichette(Tree->Left);
   InfoFiglio2 = modificaEtichette(Tree->Right);
   
   Tree->Info = Tree->Info * InfoFiglio1 * InfoFiglio2;

   return Tree->Info;
}


void stampaPostOrdineR(PtrNodoTree Tree)
   {
      if(Tree!=NULL)
      {
         stampaPostOrdineR(Tree->Left);
         stampaPostOrdineR(Tree->Right);
         printf("%d\n",Tree->Info);
      }
   }