/*Progettare un programma C che 
legge in preordine da stdin un albero binario T etichettato con caratteri
e stampa in inorder su sdtout l'albero ottenuto da T
sostituendo tutti i caratteri alfabetici minuscoli con i corrispondenti maiusoli
e tutti i caratteri alfabetici maiuscoli con i corrispondenti minuscoli.
*/


#include <stdio.h>
#include <stdlib.h>

struct nodotree {
   struct nodotree * Left;
   char Info;
   struct nodotree * Right;
};



typedef struct nodotree NodoTree;
typedef NodoTree * PtrNodoTree;


void stampaInOrdine(PtrNodoTree PtrTree);
PtrNodoTree leggiPreOrdine(void),
            creaElemento(void);
void modificaEtichette(PtrNodoTree PtrTree);

void main()
{
PtrNodoTree MyTree;

   MyTree = leggiPreOrdine();
   modificaEtichette(MyTree);
   stampaInOrdine(MyTree);
}

PtrNodoTree creaElemento(void)
{
   return (PtrNodoTree)malloc(sizeof(NodoTree));
}



PtrNodoTree leggiPreOrdine(void)
{
PtrNodoTree Nuovo;
char val;
int NumeroFigli;

   scanf("%d %c",&NumeroFigli,&val);

   Nuovo = creaElemento();

   Nuovo->Info=val;

   if(NumeroFigli==2)
   {
      Nuovo->Left=leggiPreOrdine();
      Nuovo->Right=leggiPreOrdine();
   }
   else
      if(NumeroFigli==1)
      {
         Nuovo->Left=leggiPreOrdine();
         Nuovo->Right = NULL;
      }
      else
      {
         Nuovo->Left=NULL;
         Nuovo->Right = NULL;
      }

   return Nuovo;
}


void modificaEtichette(PtrNodoTree Tree)
{
   if(Tree!=NULL) {
      if(islower(Tree->Info))
         Tree->Info = toupper(Tree->Info);
      else
         if(isupper(Tree->Info))
            Tree->Info = tolower(Tree->Info);
      
      modificaEtichette(Tree->Left);
      modificaEtichette(Tree->Right);
}


}

void stampaInOrdine(PtrNodoTree Tree)
{
   if(Tree!=NULL)
   {
      stampaInOrdine(Tree->Left);
      printf("%c\n",Tree->Info);
      stampaInOrdine(Tree->Right);
   }
}