/*
Progettare un programma C che legge da stdin una sequenza di
righe del tipo
<cmd> [<int>]
dove:
cmd e' una delle seguenti stringhe: new, left, right, up, postorder, quit
<int> e' un intero.

Il vostro programma gestisce un albero binario con il suo cursore.
Il cursore dell'albero binario e' semplicemente un puntatore
che punta ad un nodo dell'albero.
Inizialmente l'albero e' formato da un solo nodo (radice)
con etichetta 0 ed il cursore punta a tale nodo.
*/



#include <stdio.h>
#include <stdlib.h>
#define forever for(;;)

struct nodotree {

        struct nodotree * Left;
        int Info;
        struct nodotree * Right;
        };



typedef struct nodotree NodoTree;
typedef NodoTree * PtrNodoTree;

PtrNodoTree creaElemento(void);

void inizializzaAlbero(PtrNodoTree *T, PtrNodoTree *C),
     assegnaValore(PtrNodoTree C, int val);

void spostaCursoreSinistra(PtrNodoTree *C,PtrNodoTree *Padre);
void spostaCursoreDestra(PtrNodoTree *C, PtrNodoTree *Padre);
void spostaCursoreUp(PtrNodoTree *C, PtrNodoTree Padre);
void stampaPostOrder(PtrNodoTree T, PtrNodoTree C);

int main()
        {
	char cmd[10]={'\0'};
	PtrNodoTree MyTree,
		    Cursore,
		    PadreCursore;

	int valore;


	MyTree=Cursore=PadreCursore=NULL;
	
	inizializzaAlbero(&MyTree,&Cursore);	

	if(!MyTree)
		{
		printf("Memoria non disponibile\n");
		return 0;
		}
	
	scanf("%s",cmd);
	
	forever 
		{
		if(!strcmp(cmd,"quit"))
			return 0;

		if(!strcmp(cmd,"new"))
			{
			scanf("%d",&valore);
			assegnaValore(Cursore,valore);
			}
		else
			if(!strcmp(cmd,"left"))
				spostaCursoreSinistra(&Cursore,&PadreCursore);
		else
			if(!strcmp(cmd,"right"))
				spostaCursoreDestra(&Cursore,&PadreCursore);
		else 
			if(!strcmp(cmd,"up"))
				spostaCursoreUp(&Cursore,PadreCursore);
		else
			if(!strcmp(cmd,"postorder"))
				stampaPostOrder(MyTree,Cursore);

		scanf("%s",cmd);			
		
		}	

	return 0;
        }



PtrNodoTree creaElemento(void)
        {
        return (PtrNodoTree)malloc(sizeof(NodoTree));
        }



void inizializzaAlbero(PtrNodoTree *T, PtrNodoTree *C)
	{
	PtrNodoTree Nuovo;

	Nuovo = creaElemento();
	
	if(!Nuovo) return;
	
	Nuovo->Info = 0;
	Nuovo->Left = Nuovo->Right = NULL;
	
	*T = *C = Nuovo;
	}

void assegnaValore(PtrNodoTree C, int val)
	{
	
	C->Info = val;

	}


void spostaCursoreSinistra(PtrNodoTree *C,PtrNodoTree *Padre)
	{
	PtrNodoTree Nuovo;	

	
	*Padre = *C;

	if(!(*C)->Left)
		{
		Nuovo = creaElemento();
		if(!Nuovo)
			{
			printf("Memoria non disponibile\n");
			return;
			}
		Nuovo->Left = Nuovo->Right = NULL;
		Nuovo->Info = 0;
		
		(*C)->Left = Nuovo;
		*C = Nuovo;
		}
	else
		{
		*C = (*C)->Left;
		}
		

	}

void spostaCursoreDestra(PtrNodoTree *C, PtrNodoTree *Padre)
	{
	PtrNodoTree Nuovo;	

	*Padre=*C;
	if(!(*C)->Right)
		{
		Nuovo = creaElemento();
		if(!Nuovo)
			{
			printf("Memoria non disponibile\n");
			return;
			}
		Nuovo->Left = Nuovo->Right = NULL;
		Nuovo->Info = 0;
		
		(*C)->Right = Nuovo;
		*C = Nuovo;
		}
	else
		{
		*C = (*C)->Right;
		}
		

	}


void spostaCursoreUp(PtrNodoTree *C, PtrNodoTree Padre)
	{
	if(!Padre)
		return;
	*C=Padre;
	}

void stampaPostOrder(PtrNodoTree T, PtrNodoTree C)
	{
	
	if(T)
		{
		stampaPostOrder(T->Left,C);
		stampaPostOrder(T->Right,C);
		
		printf("%d",T->Info);
		
		if(T==C)
			printf(" *\n");
		else
			printf("\n");
		}


	}
