/*Progettare un programma C che 
legge in preordine da stdin un albero binario T con etichette intere,
un intero k e stampa su stdout e stampa in inorder su sdtout l'albero ottenuto
da T eliminando tutti i sottoalberi con radice k.*/

#include <stdio.h>
#include <stdlib.h>

struct nodo {
   struct nodo *Left;
   int Info;
   struct nodo *Right;
};

typedef struct nodo NodoAlbero;
typedef NodoAlbero *PtrNodo;

PtrNodo creaElemento(),
        leggiPreOrder(),
        arrivaARadiceK(PtrNodo,int);

void stampaInOrder(PtrNodo),
     eliminaAlbero(PtrNodo);

int main()
{
PtrNodo MyTree = NULL;
int k;

   MyTree = leggiPreOrder();
   
   scanf("%d",&k);
   
   arrivaARadiceK(MyTree,k);
   stampaInOrder(MyTree);

      return 0;
}

PtrNodo creaElemento()
{
   return (PtrNodo)malloc(sizeof(NodoAlbero));
}

PtrNodo leggiPreOrder()
{
PtrNodo nuovo;
int valore, numero_figli;

   nuovo = creaElemento();
   
   scanf("%d%d",&numero_figli, &valore);
   nuovo->Info = valore;

   if(numero_figli==2) {
      nuovo->Left = leggiPreOrder();
      nuovo->Right = leggiPreOrder();
   }
   else
      if(numero_figli==1) {
         nuovo->Left = leggiPreOrder();
         nuovo->Right = NULL;
      }
      else {
         nuovo->Left = NULL;
         nuovo->Right = NULL;
      }
   
   return nuovo;
}

PtrNodo arrivaARadiceK(PtrNodo t, int k)
{
   if(t==NULL)
      return t;
   
   if(t->Info == k) {
      eliminaAlbero(t);
      return NULL;
   }

   t->Left = arrivaARadiceK(t->Left,k);
   t->Right = arrivaARadiceK(t->Right,k);
   return t;
   
}

void eliminaAlbero(PtrNodo t)
{
   if(t!=NULL){
      eliminaAlbero(t->Left);
      eliminaAlbero(t->Right);
      free(t);
	}
}

void stampaInOrder(PtrNodo t)
{
   if(t!=NULL) {
      stampaInOrder(t->Left);
      printf("%d\n", t->Info);
      stampaInOrder(t->Right);
   }
}