/*
Progettare un programma C che 
legge da stdin un albero binario di caratteri in preordine e lo stampa su stdout
in postordine dopo aver trasformato i caratteri maiuscoli in minuscoli, i caratteri
minuscoli in maiuscoli, le cifre pari nel carattere 0 e le cifre dispari nel 
carattere 1.
*/

#include <stdio.h>
#include <stdlib.h>


struct nodotree {

        struct nodotree * Left;
        char Info;
        struct nodotree * Right;
        };

typedef struct nodotree NodoTree;
typedef NodoTree * PtrTree;

PtrTree creaElemento(void);
PtrTree leggiPreOrdine(void);
void modificaEtichette(PtrTree Tree);
void stampaPostOrdine(PtrTree Tree);


int main()
{
PtrTree MyTree = NULL;

   MyTree = leggiPreOrdine();
   modificaEtichette(MyTree);
   stampaPostOrdine(MyTree);

   return 0;
}

PtrTree creaElemento(void)
   {
      return (PtrTree)malloc(sizeof(NodoTree));
   }

PtrTree leggiPreOrdine(void)
   {
   PtrTree Nuovo;
   char etichetta;
   int NumeroFigli;

      scanf("%d %c",&NumeroFigli,&etichetta);

      Nuovo = creaElemento();

      Nuovo->Info=etichetta;

      if(NumeroFigli==2) {
         Nuovo->Left=leggiPreOrdine();
         Nuovo->Right=leggiPreOrdine();
         }
      else
         if(NumeroFigli==1) {
            Nuovo->Left=leggiPreOrdine();
            Nuovo->Right = NULL;
            }
         else {
            Nuovo->Left=NULL;
            Nuovo->Right = NULL;
            }


      return Nuovo;

 }



void modificaEtichette(PtrTree Tree)
{
   if(Tree!=NULL) {

      if(isalpha(Tree->Info))
         if(islower(Tree->Info))
            Tree->Info = toupper(Tree->Info);
         else
            Tree->Info = tolower(Tree->Info);
      else
         if(isdigit(Tree->Info))
            if(Tree->Info%2==0)
               Tree->Info = '0';
		else
               Tree->Info = '1'; 

      modificaEtichette(Tree->Left);
      modificaEtichette(Tree->Right);
   }
}

void stampaPostOrdine(PtrTree Tree)
   {
      if(Tree!=NULL)
      {	
         stampaPostOrdine(Tree->Left);
         stampaPostOrdine(Tree->Right);
         printf("%c\n",Tree->Info);
      }
   }