/*
Progettare un programma C che legge da stdin
un intero k ed un albero binario di interi in preordine, e stampa
su sdtout il numero di nodi dell'albero appartenenti al livello k.
La radice dell'albero si trova al livello 0. Un nodo il cui padre
e' al livello h, appartiene al livello h+1. Quindi i figli della
radice sono a livello 1, i figli dei figli della radice al livello 2 etc.

Se il numero dei livelli dell'albero e' inferiore a k, oppure se
l'albero e' vuoto, il programma stampera' in output 0.
*/

#include <stdio.h>
#include <stdlib.h>


struct nodotree {

        struct nodotree * Left;
        int Info;
        struct nodotree * Right;
        };

typedef struct nodotree NodoTree;
typedef NodoTree * PtrTree;

PtrTree creaElemento(void);
PtrTree leggiPreOrdine(void);
void ContaFigli(PtrTree T, int livello, int *numero);


int main()
{
PtrTree MyTree = NULL;
int k,numero=0;

   scanf("%d",&k);

   MyTree = leggiPreOrdine();
   ContaFigli(MyTree,k,&numero);
   printf("%d\n",numero);

}

PtrTree creaElemento(void)
   {
      return (PtrTree)malloc(sizeof(NodoTree));
   }

PtrTree leggiPreOrdine(void)
   {
   PtrTree Nuovo;
   int etichetta;
   int NumeroFigli;

      scanf("%d %d",&NumeroFigli,&etichetta);

      Nuovo = creaElemento();

      Nuovo->Info=etichetta;

      if(NumeroFigli==2) {
         Nuovo->Left=leggiPreOrdine();
         Nuovo->Right=leggiPreOrdine();
         }
      else
         if(NumeroFigli==1) {
            Nuovo->Left=leggiPreOrdine();
            Nuovo->Right = NULL;
            }
         else {
            Nuovo->Left=NULL;
            Nuovo->Right = NULL;
            }


      return Nuovo;

 }

void ContaFigli(PtrTree T, int livello, int *numero)
{
   if(T!=NULL)
   {
   if(livello == 0) 
      (*numero)++;
   else
   {
      ContaFigli(T->Left,livello - 1, numero);
      ContaFigli(T->Right,livello-1, numero);
   }
}



}


