/* PREPOCESSORE */
#define NUMELEM 50
#define RIGHE 10
#include <stdio.h>

/*---------------------------------------------------------------------------------------------
Come e' stato suggerito ho utilizzato un vettore e una matrice. In generale l'algoritmo puo'
essere sintetizzato in questo modo:

	1) Leggo da stdin i valori da ordinare e li inserisco nel vettore.
	2) Scandisco il vettore e inserisco i suoi valori in una riga della matrice(di 10 righe 
	   e numero di colonne pari alla lunghezza del vettore) basandomi sulla cifra delle
	   unita'.
	3) A questo punto, ricopio gli elementi della matrice(leggendoli da sinistra verso
	   destra, dall'alto verso il basso, nel vettore.
        4) Ripeto il passo 2) e 3) basandomi sulle cifre successive, cioe' quelle relative
	   alle decine, alle centinaia, alle migliaia ecc...
        5) Mi fermo quando sara' stata elaborata l'ultima cifra piu' significativa del
	   numero piu' grande. I valori a questo punto saranno tutti presenti nella prima riga.
----------------------------------------------------------------------------------------------*/

/*PROTOTIPI FUNZIONI*/


void riempiMatrice(long int v[],long int m[][NUMELEM],int dim, int cifra);
int controllaPrimaRigaMatrice(long int m[][NUMELEM],int cifracorrente);
void stampaVettore(long int v[],int dim);
void riempiVettore(long int v[],int dim);
void pulisciMatrice(long int m[][NUMELEM]);
void CopiaMatriceInVettore(long int v[],long int m[][NUMELEM]);
int troncaNumero(long int numero, int cifra);



void main()
{
long int matrice[10][NUMELEM];
long int vettore[NUMELEM]={0};
int i,j;
int passata=0;
int C=0;

printf("Davide\nSammartino\n12\n05\n1983\ndaviduzzo83@yahoo.it\n");


pulisciMatrice(matrice);

riempiVettore(vettore,NUMELEM);



while(C!=1) {

        riempiMatrice(vettore,matrice,NUMELEM,passata);

        CopiaMatriceInVettore(vettore,matrice);

        C=controllaPrimaRigaMatrice(matrice,passata);

        pulisciMatrice(matrice);
        
        passata++;
}

stampaVettore(vettore,NUMELEM);

printf("%d",passata);

}



/*----------------------------------------------------------------------------
Questa procedura serve semplicemente per stampare il vettore contenente i valori
ordinati.*/
void stampaVettore(long int v[],int dim)
{
int i;
for(i=0;i<dim;i++)
        printf("%d\n",v[i]);
}


/*----------------------------------------------------------------------------
Questa procedura inizializza il vettore con i valori da ordinare.*/
void riempiVettore(long int v[],int dim)
{
int i;
for(i=0;i<dim;i++)
        scanf("%d",&v[i]);
}


/*----------------------------------------------------------------------------
La procedura pulisciMatrice, 'svuota' la matrice, ponendo tutti i suoi elementi
a -1 */
void pulisciMatrice(long int m[][NUMELEM]){
int i,j;

for(i=0;i<RIGHE;i++)
        for(j=0;j<NUMELEM;j++)
                m[i][j]= -1;
}
/*-----------------------------------------------------------------------------
Ad un certo punto del programma sara' necessario copiare ogni elemento della
matrice(da sinistra verso destra, dall'alto verso il basso) nel vettore */

void CopiaMatriceInVettore(long int v[],long int m[][NUMELEM])
{
int i,j,k;
k=0;
for(i=0;i<RIGHE;i++)
        for(j=0;j<NUMELEM&&m[i][j]!=-1;j++)
           {
           v[k] = m[i][j];
           k++;
           }

}

/*---------------------------------------------------------------------------
Questa e' la procedura piu' importante del programma. Essa riempie la matrice
con i valori contenuti nel vettore da ordinare, sistemandoli al suo interno
basandosi sulla cifra di quel particolare valore. Ma come poter estrarre la
cifra di quel numero? E' stata implementata, a questo scopo, la funzione
troncaNumero, che appunto tronca il numero a una determinata cifra(vedi sotto).
Una volta che si ha il numero troncato, la cifra che si vuole estrarre si trova
nell'ultima posizione. Per estrarla a tutti gli effetti, basta calcolare il
resto della divisione per dieci, cioe':

        si vuole estrarre l'ultima cifra di 1234:
        il resto della divisione per dieci e' proprio 4!

A questo punto basta inserire il valore nella matrice nella riga corrispondente
alla cifra estratta, e colonna... beh la colonna dipende da quanti numeri gia'
sono inseriti in quella riga. E' utile allora un ciclo che posizionera' il
nostro numero non appena in contra una cella vuota della riga in considerazione.
Quindi, essendo una cella vuota rappresentata da -1, si sistemera' il valore
non appena si incontra la cella con valore -1.
*/

void riempiMatrice(long int v[],long int m[][NUMELEM],int dim, int cifra) {
int i,j,cifradecimale;

for(i=0;i<dim;i++){
        cifradecimale = troncaNumero(v[i],cifra) % 10;
        for(j=0;m[cifradecimale][j]!=-1;j++) {}
        m[cifradecimale][j]=v[i];
}

}


void stampaMatrice(long int m[][NUMELEM])
{
int i,j;

for(i=0;i<RIGHE;i++){
	for(j=0;j<NUMELEM;j++)
		printf("%12d",m[i][j]);
	printf("\n");
}
}

/*----------------------------------------------------------------------------
Questa funzione tronca un numero a una determinata cifra. Ad esempio se si deve
troncare il numero 1234 alla cifra di posizione 2 (NB:la posizione della prima
cifra e' 0) basta solamente effettuare un numero di divisioni INTERE pari a 2:

        1234 / 10 = 123        prima divisione
        1234 / 10 = 12         seconda divisione

        fine ciclo

        restituisci numero.
*/

int troncaNumero(long int numero, int cifra) {
int i;

for(i=0;i<cifra;i++)
        numero /= 10;

return numero;
}

/*---------------------------------------------------------------------------
Questa funzione esamina gli elementi della prima riga della matrice.
L'algoritmo Backet Sort, infatti, sapra' di aver terminato il proprio compito,
quando tutti valori saranno ricopiati nella prima riga della matrice e non ci
saranno piu' cifra da esaminare. Questo significa che i numeri potrebbero essere
nella prima riga della matrice anche se l'algoritmo non ha finito il suo compito:
infatti ordinando i numeri 105,103,104, quando si esaminera' la cifra delle
decine, cioe' quella di posizione 1, i numeri si troveranno nella prima riga ma
non e' detto che siano ordinati.Invece l'algoritmo dovra' finire quando non ci
saranno piu' cifre da esaminare.
Questo concetto si puo' implementari in diversi modi, ad esempio, dire che
si sta elaborando la cifra successiva a quella del numero piu' grande significa
che tutti i numeri saranno minori della potenza di 10 con esponente pari alla
cifra: ad esempio

se si hanno i numeri 10,190 e 14, l'algoritmo finira' di ordinare quando si
stara esamindo la cifra di posizione successiva a quella del numero piu' grande
(che e' 190) cioe' la cifra di posizione 3 (le cifre partono da 0), questo
sigifica che tutti i numeri saranno minori della potenza di 10 di quella cifra,
che nel nostro caso e' 10 elevato a 3(le migliaia).Questo pero' comporta dei
confronti tra numeri anche molto grandi, piu' grandi del limite di un long int!

Allora si puo' ragionare in questo modo. Facciamo prima questo esempio:

        innanzitutto dire che un numero e' maggiore di 100 e' equivalente a dire
        che se tronco il numero alla cifra di posizione 2 e se la parte
        rimanente e' maggiore di 0, allora il numero e' piu' grande di 100.
        Infatti troncando 1245 alla cifra 2, risulta 12 > 0, quindi 1245 >100.

        Simmetricamente per dire che numero e' minore di 100 e' equivalente a
        dire che se tronco il numero alla cifra di posizione 2 e se la parte
        rimanente e' uguale a 0, allora il numero e' piu' piccolo di 100.
        Prendiamo ad esempio 90, se mi calcolo la parte rimanente prima della
        cifra num. 2, risulta 0 ( e' come vedere 90 = ...0000000090). Quindi
        90 < 100.

In generale se voglio
stabilire che un numero e' minore di una potenza di 10^n posso calcolare la
parte rimanente del numero(troncare appunto) fino alla n_esima cifra (con n
che parte da 0!) Se la parte rimanente e' proprio 0, ALLORA il numero e' minore
di 10^n.
Questo e' quello che e' stato implementato in questa funzione che scandisce
tutto la prima riga della matrice, fa gli opportuni controlli, e restituisce
1 se tutti i numeri sono minori di 10^n.*/

int controllaPrimaRigaMatrice(long int m[][NUMELEM],int cifracorrente)
{
int i;

for(i=0;i<NUMELEM&&m[0][i]!=-1&&troncaNumero(m[0][i],cifracorrente)==0;i++);

if (i==NUMELEM) return 1;
return 0;
}
