#include<stdlib.h>
#include<stdio.h>
#include<string.h>
#define persempre for(;;)

struct nodo {
        int Info;
        struct nodo *Prev;
        struct nodo *Next;
};

typedef struct nodo Nodo;
typedef Nodo* PtrNodo;

/*---------------------------------------------------------------------------*/
/*--Prototipi funzioni----------------------------------------------------*/

int DividiLista(PtrNodo Inizio,PtrNodo * P,PtrNodo * Q,int i);

void cancellaElemento(PtrNodo *InizioLista,PtrNodo *Cursore),
     stampaLista(PtrNodo InizioLista,PtrNodo Cursore),
     aggiungiElemento(PtrNodo *InizioLista, PtrNodo *Cursore, int info);

PtrNodo creaElemento(),
        merge(PtrNodo P, PtrNodo Q),
        MergeSort(PtrNodo Inizio),
        cursoreASinistra(PtrNodo Cursore),
        cursoreADestra(PtrNodo Cursore);

/*---------------------------------------------------------------------------*/
/*---Programma principale----------------------------------------------------*/

int main()
{
        PtrNodo Inizio=NULL,
                Cursore=NULL;

        int val;

        char comando[10]="";

        persempre {

            scanf("%s",comando);

            if(!strcmp(comando,"fine"))
                        return 0;

            if(!strcmp(comando,"print")) {
                        if(Inizio==NULL)
                                printf("vuota\n");
                        else
                                stampaLista(Inizio,Cursore);
                        }

            else if(!strcmp(comando,"del")){
                        if(Inizio==NULL)
                                printf("vuota\n");
                        else
                                cancellaElemento(&Inizio,&Cursore);
                        }

            else if(!strcmp(comando,"next"))
                        {
                        Cursore = cursoreADestra(Cursore);
                        }
            else if(!strcmp(comando,"prev"))
                        {
                        Cursore = cursoreASinistra(Cursore);
                        }
            else if(!strcmp(comando,"add"))
                   {
                   if(scanf("%d",&val)==1);
                   aggiungiElemento(&Inizio,&Cursore,val);
                   }
            else if(!strcmp(comando,"sort"))
                        {
                        if(!Inizio)
                                printf("vuota\n");
                        else
                                Inizio= MergeSort(Inizio);
                        }

            }
}

/*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*/




PtrNodo creaElemento()
        {
        return (PtrNodo)malloc(sizeof(Nodo));
        }

/*---------------------------------------------------------------------------*/


void aggiungiElemento(PtrNodo *InizioLista, PtrNodo *Cursore, int Info)
        {
        PtrNodo P;

        if(*InizioLista==NULL)                  /*  La lista e' vuota?            */
                {
                P = creaElemento();

                P->Info=Info;                   /*  Creo un nuovo nodo e lo       */
                P->Prev=NULL;                   /*  aggingo nella prima posizione */
                P->Next=NULL;

                *InizioLista=*Cursore=P;
                }
        else
                {                                /*  La lista ha almeno un elemento*/
                P=creaElemento();

                P->Info=Info;                    /*  Creo un nodo e lo aggiungo tra*/
                P->Prev=*Cursore;                /*  l'elem. puntato dal cursore e */
                P->Next=(*Cursore)->Next;        /*  il nodo successivo.           */

                if((*Cursore)->Next!=NULL)       /* Se il nodo succ. al cursore    */
                    (*Cursore)->Next->Prev=P;    /* non esiste allora il nuovo     */
                                                 /* nodo diventa l'ultimo elem.    */
                (*Cursore)->Next=P;              /* Il nodo precedente ora punta   */
                *Cursore=P;                      /* all'elemento aggiunto. Il      */
                }                                /* cursore viene posizionato sul  */
                                                 /* nuovo elemento.                */
        }

/*---------------------------------------------------------------------------*/


PtrNodo cursoreADestra(PtrNodo Cursore)
        {
        if(Cursore==NULL) return NULL;          /* Il cursore e' NULL? allora torna NULL                        */
        if(Cursore->Next==NULL)return Cursore;  /* Il cursore e' posizionato sull'ultimo elemento? allora torna */
        return Cursore->Next;                   /* non viene spostato.                                          */

        }


/*---------------------------------------------------------------------------*/



PtrNodo cursoreASinistra(PtrNodo Cursore)
        {                                                 /* Il cursore viene spostato sul nodo */
        if(Cursore==NULL) return NULL;
        if(Cursore->Prev==NULL)return Cursore;            /* precedente, se esiste, altrimenti  */
        return Cursore->Prev;                             /* non viene spostato.                */

        }

/*---------------------------------------------------------------------------*/


void stampaLista(PtrNodo InizioLista,PtrNodo Cursore)
{

        if(InizioLista!=NULL)
        {
                printf("%d",InizioLista->Info);          /* Stampo il campo informazione del nodo corrente */
                if(Cursore==InizioLista)                 /* Se il nodo corrente e' quello su cui e'        */
                        printf(" * ");                   /* e' posizionato il cursore allora stampo "*".   */
                printf("\n");
                stampaLista(InizioLista->Next,Cursore);  /* Chiamata ricorsiva alla quale si passa il nodo */
        }                                                /* successivo.                                    */

}

/*---------------------------------------------------------------------------*/

void cancellaElemento(PtrNodo *InizioLista,PtrNodo *Cursore)
        {
        PtrNodo Precedente,Successivo;

        Precedente=(*Cursore)->Prev;                    /* Memorizzo gli indirizzi del nodo   */
        Successivo=(*Cursore)->Next;                    /* Precedente e Successivo rispetto al*/
                                                        /* cursore.                           */

        if(Precedente==NULL&&Successivo==NULL)          /* La lista ha un solo elemento?      */
                {                                       /* allora                             */
                free(*Cursore);                         /* libero la memoria occupata dall'ele*/
                *Cursore=NULL;                          /* mento puntato dal cursore.         */
                *InizioLista=NULL;                      /* La lista ora e' vuota.             */
                }

        else                                            /* altrimenti                          */
                {
                if(Precedente==NULL)                    /*Siamo posizionati sul primo elemento?*/
                        {                               /*allora                               */
                        free(*Cursore);                 /*Libero la memoria                    */
                        Successivo->Prev=NULL;          /*Il nodo Successivo diventa il primo  */
                        (*Cursore)=Successivo;          /*nodo della lista. Sposto il cursore  */
                        (*InizioLista)=Successivo;      /*sul nodo Successivo, e anche il ptr  */
                        }                               /*alla lista.                          */
                else                                    /*Altrimenti                           */
                        {
                        if(Successivo==NULL)            /*Siamo nell'ultimo nodo?              */
                                {

                                free(*Cursore);                 /*Libero la memoria.                                  */
                                Precedente->Next=Successivo;    /*Il nodo precendente al cursore diventa l'ultimo nodo*/
                                (*Cursore)=Precedente;          /*Il cursore viene posizionato sul nodo Precedente.   */

                                }
                        else                                    /*altrimenti siamo in un nodo qualunque*/
                                {
                                free(*Cursore);                 /*Libero la memoria.                      */
                                Precedente->Next=Successivo;    /*Ricollego correttamente i nodi ai lati  */
                                Successivo->Prev=Precedente;    /*del cursore rimasti senza nodo centrale.*/
                                (*Cursore)=Successivo;          /*Il cursore e' posto sul nodo successivo.*/
                                }
                         }



                }

        }

/*---------------------------------------------------------------------------*/
/* La funzione divide in due parti una lista prendendo i nodi di posizione
   dispari e di posizione pari. Ad esempio, data la lista:

 inizio
 -----    -----     -----     -----     -----     -----     -----
 |    |   |12  |    | 20 |    | 14 |    | 55 |    | 36 |    | 11 |
 | *--|-->| *--|--->| *--|--->| *--|--->| *--|--->| *--|--->|null|
 -----    -----     -----     -----     -----     -----     -----

   dopo la chiamata alla funzione avremo:

 *Q
 -----    -----     -----     -----
 |    |   |12  |    | 14 |    | 36 |
 | *--|-->| *--|--->| *--|--->|null|
 -----    -----     -----     -----


 *P
 -----    -----     -----     -----
 |    |   | 20 |    | 55 |    | 11 |
 | *--|-->| *--|--->| *--|--->|null|
 -----    -----     -----     -----

   (il disegno non fa riferimento al fatto che le liste sono doppiamente linkate).*/

/*La funzione arriva ricorsivamente all'ultimo elemento della lista, a questo
  punto scorrendola al contrario lega fra loro gli elementi dispari e
  contemporamente lega tra loro gli elementi pari.                             */

int DividiLista(PtrNodo Inizio,PtrNodo * P,PtrNodo * Q,int i)
        {
        PtrNodo temp;

        if(Inizio==NULL)             /*Siamo alla fine della lista?             */
                {                    /*allora                                   */
                *Q=NULL;             /*Pongo a NULL i puntatori alle due liste  */
                *P=NULL;
                return !i;           /*Ritorno "i"                              */
                }

        else                                            /*Altrimenti                               */
                {
                i=DividiLista(Inizio->Next,P,Q,i);      /*Faccio avanzare il puntatore alla lista  */
                                                        /*Se sono qui, vuol dire che sto percorrendo*/
                                                        /*la lista al contrario.                    */

                if(i)                                   /*"i" e' affermato?                         */
                        {
                        temp=*P;                        /*Allora *P diventa uguale al nodo puntato  */
                        (*P)=Inizio;                    /*da Inizio.                                */
                        (*P)->Next=temp;                /*Il nodo *P deve puntare a quello puntato  */
                        }                               /*in precedenza da *P.                      */
                else
                        {
                        temp=*Q;                        /*Vedi le operazioni per *P                 */
                        (*Q)=Inizio;
                        (*Q)->Next=temp;
                        }

                return !i;                              /*Nego i.                                   */
                }
        }


/*---------------------------------------------------------------------------*/


PtrNodo merge(PtrNodo P, PtrNodo Q)
        {

        if(P==NULL) return Q;
        if(Q==NULL) return P;

        if(P->Info<=Q->Info)
                {
                P->Next=merge(P->Next,Q);
                P->Next->Prev=P;
                return P;
                }
        else
                {
                Q->Next = merge(P,Q->Next);
                Q->Next->Prev=Q;
                return Q;
                }
        }

/*---------------------------------------------------------------------------*/

PtrNodo MergeSort(PtrNodo Inizio)
        {
        if(Inizio->Next==NULL)                 /*Se la lista ha un solo elemento e' */
                return Inizio;                            /*gia' ordinata.*/
        else
                {                              /*La lista ha almeno due elementi    */
                PtrNodo P,Q,temp;
                int i=0;

                DividiLista(Inizio,&P,&Q,i);   /*Divido la lista in due parti       */

                P=MergeSort(P);                /*Chiamo ricorsivamente la funzione  */
                Q=MergeSort(Q);                /*per ognuna delle due parti formate */

                temp=merge(P,Q);               /*Eseguo il Merge delle due liste    */
                temp->Prev=NULL;               /*Il primo elemento ha campo Prev    */
                                               /*uguale a NULL                      */
                return temp;                   /*ritorno il puntatore alla lista    */
                }                              /*ordinata.                          */

        }



/*---------------------------------------------------------------------------*/
