/*------------------------Tree.h-----------------------------*/
/*----------Alberi binari e relative funzioni----------------*/

#include <stdio.h>
#include <stdlib.h>

struct nodotree {
   struct nodotree * Left;
   char Info;
   struct nodotree * Right;
};



typedef struct nodotree NodoTree;
typedef NodoTree * PtrTree;

PtrTree creaElemento(void),
        leggiPreOrdine(void),
        leggiInOrdine(void),
        leggiPostOrdine(void);

void stampaPreOrdine(PtrTree Tree),
     stampaInOrdine(PtrTree Tree),
     stampaPostOrdine(PtrTree Tree);


/* Allocazione di un nodo di un albero */

PtrTree creaElemento(void)
        {
        return (PtrTree)malloc(sizeof(NodoTree));
        }

/* Fine allocazione */


/* Lettura di un albero in Pre Ordine */

PtrTree leggiPreOrdine(void)
{
   PtrTree Nuovo;
   int L,R;

   Nuovo = creaElemento();

   if(!Nuovo)
      printf("Memoria insufficiente");
   else
   {
      scanf("%d",&(Nuovo->Info));
      scanf("%d%d",&L,&R);

      if(L!=0)
         Nuovo->Left = leggiPreOrdine();
      else
         Nuovo->Left = NULL;

      if(R!=0)
         Nuovo->Right = leggiPreOrdine();
      else
         Nuovo->Right = NULL;
   }
   return Nuovo;
}
/* Fine lettura albero */



/* Lettura di un albero in In Ordine */

PtrTree leggiInOrdine()
{
   PtrTree Nuovo;
   int L,R;

   scanf("%d%d",&L,&R);

   Nuovo = creaElemento();

   if(!Nuovo)
      printf("Memoria insufficiente");
   else
   {
      if(L!=0)
         Nuovo->Left=leggiInOrdine();
      else
         Nuovo->Left = NULL;

      scanf("%d",&(Nuovo->Info));

      if(R!=0)
         Nuovo->Right=leggiInOrdine();
      else
         Nuovo->Right = NULL;
   }
   return Nuovo;
}
/* Fine lettura albero */


/* Lettura di un albero in Post Ordine */
PtrTree leggiPostOrdine()
{
   PtrTree Nuovo;
   int L,R;

   scanf("%d%d",&L,&R);

   Nuovo = creaElemento();

   if(!Nuovo)
      printf("Memoria insufficiente");
   else
   {
      if(L!=0)
         Nuovo->Left=leggiPostOrdine();
      else
         Nuovo->Left = NULL;

      if(R!=0)
         Nuovo->Right=leggiPostOrdine();
      else
         Nuovo->Right = NULL;

      scanf("%d",&(Nuovo->Info));
   }
   return Nuovo;
}
/* Fine Lettura */


/*Stampa di un albero in Pre Ordine */
void stampaPreOrdine(PtrTree Tree)
{
   if(Tree!=NULL)
   {
      printf("%d\n",Tree->Info);
      
      if(Tree->Left)
	   printf("1 ");
      else 
	   printf("0 ");
		
	if(Tree->Right)
	   printf("1\n");
      else 
	   printf("0\n");

      stampaPreOrdine(Tree->Left);
      stampaPreOrdine(Tree->Right);
   }
}
/* Fine stampa */


/* Stampa di un albero in In Ordine */
void stampaInOrdine(PtrTree Tree)
{
   if(Tree!=NULL)
   {
      if(Tree->Left)
	   printf("1 ");
	else 
	   printf("0 ");
		
	if(Tree->Right)
	   printf("1\n");
	else 
	   printf("0\n");
   
      stampaInOrdine(Tree->Left);
      printf("%d\n",Tree->Info);
      stampaInOrdine(Tree->Right);
   }
}
/* Fine stampa */


/*Stampa di un albero in PostOrdine */
void stampaPostOrdine(PtrTree Tree)
{
   if(Tree!=NULL)
   {
      if(Tree->Left)
	   printf("1 ");
	else 
	   printf("0 ");
		
      if(Tree->Right)
         printf("1\n");
	else 
	   printf("0\n");

      stampaPostOrdine(Tree->Left);
      stampaPostOrdine(Tree->Right);
      printf("%d\n",Tree->Info);
   }
}
/* Fine stampa */


